package ru.dbotthepony.mc.otm.block.entity;

import net.minecraft.core.BlockPos;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.StringTag;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.world.MenuProvider;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;

import javax.annotation.Nullable;

public abstract class BlockEntityMatteryMachine extends BlockEntity implements MenuProvider {
	protected Component display_name;

	public BlockEntityMatteryMachine(BlockEntityType<?> p_155228_, BlockPos p_155229_, BlockState p_155230_) {
		super(p_155228_, p_155229_, p_155230_);
	}

	public void setDisplayName(Component text) {
		display_name = text;
	}

	protected Component getDefaultDisplayName() {
		return new TranslatableComponent("container.otm.unknown");
	}

	@Override
	public Component getDisplayName() {
		return display_name != null ? display_name : getDefaultDisplayName();
	}

	@Nullable
	@Override
	abstract public AbstractContainerMenu createMenu(int containerID, Inventory inventory, Player ply);

	public boolean canOpenMachine(Player ply) {
		return false;
	}

	@Override
	public CompoundTag save(CompoundTag nbt) {
		if (display_name != null)
			nbt.putString("Name", Component.Serializer.toJson(display_name));

		return super.save(nbt);
	}

	public void load(CompoundTag nbt) {
		super.load(nbt);

		if (nbt.contains("Name") && nbt.get("Name") instanceof StringTag tag)
			display_name = Component.Serializer.fromJson(tag.getAsString());
	}
}
