package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraftforge.common.util.LazyOptional;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityBatteryBank;
import ru.dbotthepony.mc.otm.capability.IMatteryEnergyStorage;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.data.BigDecimalDataContainer;
import ru.dbotthepony.mc.otm.menu.slot.BatterySlot;

import javax.annotation.Nullable;

public class BatteryBankMenu extends MatteryMenu {
	protected BlockEntityBatteryBank tile;

	public BigDecimalDataContainer energy;
	public BigDecimalDataContainer max_energy;

	public BatteryBankMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null, new SimpleContainer(5 * 3));
	}

	public BatteryBankMenu(int p_38852_, Inventory inventory, BlockEntityBatteryBank tile, Container batteries) {
		super(Registry.Menus.BATTERY_BANK, p_38852_, inventory, tile);
		this.tile = tile;

		if (tile == null) {
			energy = new BigDecimalDataContainer();
			max_energy = new BigDecimalDataContainer();
		} else {
			energy = new BigDecimalDataContainer() {
				@Override
				protected void updateValue() {
					setDecimal(tile.energy.getBatteryLevel());
				}
			};
			max_energy = new BigDecimalDataContainer() {
				@Override
				protected void updateValue() {
					setDecimal(tile.energy.getMaxBatteryLevel());
				}
			};
		}

		this.addDataSlots(energy);
		this.addDataSlots(max_energy);

		for (int row = 0; row < 3; row++)
			for (int column = 0; column < 5; column++)
				this.addSlot(new BatterySlot(batteries, row * 5 + column, 62 + column * 18, 24 + row * 18));

		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 5 * 3;
	}
}
