package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import net.minecraftforge.common.util.LazyOptional;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatteryPoweredMachine;
import ru.dbotthepony.mc.otm.capability.IMatteryEnergyStorage;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.data.BigDecimalDataContainer;
import ru.dbotthepony.mc.otm.menu.slot.BatterySlot;

import javax.annotation.Nullable;

abstract public class PoweredMatteryMenu extends MatteryMenu {
	protected BlockEntityMatteryPoweredMachine tile;

	public BigDecimalDataContainer energy;
	public BigDecimalDataContainer max_energy;

	protected PoweredMatteryMenu(
			@Nullable MenuType<?> menuType,
			int containerID,
			Inventory inventory,
			@Nullable BlockEntityMatteryPoweredMachine tile
	) {
		super(menuType, containerID, inventory, tile);

		if (tile == null) {
			energy = new BigDecimalDataContainer();
			max_energy = new BigDecimalDataContainer();
		} else {
			energy = new BigDecimalDataContainer() {
				@Override
				protected void updateValue() {
					LazyOptional<IMatteryEnergyStorage> capability = tile.getCapability(MatteryCapability.ENERGY);

					if (capability.isPresent())
						setDecimal(capability.resolve().get().getBatteryLevel());
				}
			};

			max_energy = new BigDecimalDataContainer() {
				@Override
				protected void updateValue() {
					LazyOptional<IMatteryEnergyStorage> capability = tile.getCapability(MatteryCapability.ENERGY);

					if (capability.isPresent())
						setDecimal(capability.resolve().get().getMaxBatteryLevel());
				}
			};
		}

		this.addDataSlots(energy);
		this.addDataSlots(max_energy);
	}

	protected void addBatterySlot() {
		addBatterySlot(8, 66);
	}

	protected void addBatterySlot(int x, int y) {
		Container battery_container = tile != null ? tile.battery_container : new SimpleContainer(1);
		this.addSlot(new BatterySlot(battery_container, 0, x, y));
	}
}
